
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyDescription;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonValue;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "inkarnation",
    "rechner",
    "letzteStartzeit",
    "letzteInitialisierung",
    "letzteStoppzeit",
    "status",
    "startMeldung"
})
public class Applikation implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnation")
    private Inkarnation inkarnation;
    @JsonProperty("rechner")
    private String rechner;
    /**
     * die letzte Startzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStartzeit")
    @JsonPropertyDescription("die letzte Startzeit der Inkarnation")
    private String letzteStartzeit;
    /**
     * die letzte Initialisierungszeit der Inkarnation
     * 
     */
    @JsonProperty("letzteInitialisierung")
    @JsonPropertyDescription("die letzte Initialisierungszeit der Inkarnation")
    private String letzteInitialisierung;
    /**
     * die letzte Stoppzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStoppzeit")
    @JsonPropertyDescription("die letzte Stoppzeit der Inkarnation")
    private String letzteStoppzeit;
    /**
     * der Status der Inkarnation in StartStopp
     * (Required)
     * 
     */
    @JsonProperty("status")
    @JsonPropertyDescription("der Status der Inkarnation in StartStopp")
    private Applikation.Status status;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startMeldung")
    private String startMeldung;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -7458966003717779877L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public Applikation() {
    }

    /**
     * 
     * @param rechner
     * @param letzteInitialisierung
     * @param startMeldung
     * @param letzteStartzeit
     * @param letzteStoppzeit
     * @param inkarnation
     * @param status
     */
    public Applikation(Inkarnation inkarnation, String rechner, String letzteStartzeit, String letzteInitialisierung, String letzteStoppzeit, Applikation.Status status, String startMeldung) {
        super();
        this.inkarnation = inkarnation;
        this.rechner = rechner;
        this.letzteStartzeit = letzteStartzeit;
        this.letzteInitialisierung = letzteInitialisierung;
        this.letzteStoppzeit = letzteStoppzeit;
        this.status = status;
        this.startMeldung = startMeldung;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnation")
    public Inkarnation getInkarnation() {
        return inkarnation;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnation")
    public void setInkarnation(Inkarnation inkarnation) {
        this.inkarnation = inkarnation;
    }

    public Applikation withInkarnation(Inkarnation inkarnation) {
        this.inkarnation = inkarnation;
        return this;
    }

    @JsonProperty("rechner")
    public String getRechner() {
        return rechner;
    }

    @JsonProperty("rechner")
    public void setRechner(String rechner) {
        this.rechner = rechner;
    }

    public Applikation withRechner(String rechner) {
        this.rechner = rechner;
        return this;
    }

    /**
     * die letzte Startzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStartzeit")
    public String getLetzteStartzeit() {
        return letzteStartzeit;
    }

    /**
     * die letzte Startzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStartzeit")
    public void setLetzteStartzeit(String letzteStartzeit) {
        this.letzteStartzeit = letzteStartzeit;
    }

    public Applikation withLetzteStartzeit(String letzteStartzeit) {
        this.letzteStartzeit = letzteStartzeit;
        return this;
    }

    /**
     * die letzte Initialisierungszeit der Inkarnation
     * 
     */
    @JsonProperty("letzteInitialisierung")
    public String getLetzteInitialisierung() {
        return letzteInitialisierung;
    }

    /**
     * die letzte Initialisierungszeit der Inkarnation
     * 
     */
    @JsonProperty("letzteInitialisierung")
    public void setLetzteInitialisierung(String letzteInitialisierung) {
        this.letzteInitialisierung = letzteInitialisierung;
    }

    public Applikation withLetzteInitialisierung(String letzteInitialisierung) {
        this.letzteInitialisierung = letzteInitialisierung;
        return this;
    }

    /**
     * die letzte Stoppzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStoppzeit")
    public String getLetzteStoppzeit() {
        return letzteStoppzeit;
    }

    /**
     * die letzte Stoppzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStoppzeit")
    public void setLetzteStoppzeit(String letzteStoppzeit) {
        this.letzteStoppzeit = letzteStoppzeit;
    }

    public Applikation withLetzteStoppzeit(String letzteStoppzeit) {
        this.letzteStoppzeit = letzteStoppzeit;
        return this;
    }

    /**
     * der Status der Inkarnation in StartStopp
     * (Required)
     * 
     */
    @JsonProperty("status")
    public Applikation.Status getStatus() {
        return status;
    }

    /**
     * der Status der Inkarnation in StartStopp
     * (Required)
     * 
     */
    @JsonProperty("status")
    public void setStatus(Applikation.Status status) {
        this.status = status;
    }

    public Applikation withStatus(Applikation.Status status) {
        this.status = status;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startMeldung")
    public String getStartMeldung() {
        return startMeldung;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startMeldung")
    public void setStartMeldung(String startMeldung) {
        this.startMeldung = startMeldung;
    }

    public Applikation withStartMeldung(String startMeldung) {
        this.startMeldung = startMeldung;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public Applikation withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("inkarnation", inkarnation).append("rechner", rechner).append("letzteStartzeit", letzteStartzeit).append("letzteInitialisierung", letzteInitialisierung).append("letzteStoppzeit", letzteStoppzeit).append("status", status).append("startMeldung", startMeldung).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(rechner).append(letzteInitialisierung).append(startMeldung).append(letzteStartzeit).append(letzteStoppzeit).append(additionalProperties).append(inkarnation).append(status).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof Applikation) == false) {
            return false;
        }
        Applikation rhs = ((Applikation) other);
        return new EqualsBuilder().append(rechner, rhs.rechner).append(letzteInitialisierung, rhs.letzteInitialisierung).append(startMeldung, rhs.startMeldung).append(letzteStartzeit, rhs.letzteStartzeit).append(letzteStoppzeit, rhs.letzteStoppzeit).append(additionalProperties, rhs.additionalProperties).append(inkarnation, rhs.inkarnation).append(status, rhs.status).isEquals();
    }

    public enum Status {

        INSTALLIERT("installiert"),
        STARTENWARTEN("startenwarten"),
        GESTARTET("gestartet"),
        INITIALISIERT("initialisiert"),
        STOPPENWARTEN("stoppenwarten"),
        GESTOPPT("gestoppt");
        private final String value;
        private final static Map<String, Applikation.Status> CONSTANTS = new HashMap<String, Applikation.Status>();

        static {
            for (Applikation.Status c: values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        private Status(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return this.value;
        }

        @JsonValue
        public String value() {
            return this.value;
        }

        @JsonCreator
        public static Applikation.Status fromValue(String value) {
            Applikation.Status constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }

}
