
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyDescription;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "inkarnation",
    "messages"
})
public class ApplikationLog implements Serializable
{

    /**
     * der Name der Inkarnation
     * (Required)
     * 
     */
    @JsonProperty("inkarnation")
    @JsonPropertyDescription("der Name der Inkarnation")
    private String inkarnation;
    @JsonProperty("messages")
    private List<String> messages = new ArrayList<String>();
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 1553556408908935119L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public ApplikationLog() {
    }

    /**
     * 
     * @param messages
     * @param inkarnation
     */
    public ApplikationLog(String inkarnation, List<String> messages) {
        super();
        this.inkarnation = inkarnation;
        this.messages = messages;
    }

    /**
     * der Name der Inkarnation
     * (Required)
     * 
     */
    @JsonProperty("inkarnation")
    public String getInkarnation() {
        return inkarnation;
    }

    /**
     * der Name der Inkarnation
     * (Required)
     * 
     */
    @JsonProperty("inkarnation")
    public void setInkarnation(String inkarnation) {
        this.inkarnation = inkarnation;
    }

    public ApplikationLog withInkarnation(String inkarnation) {
        this.inkarnation = inkarnation;
        return this;
    }

    @JsonProperty("messages")
    public List<String> getMessages() {
        return messages;
    }

    @JsonProperty("messages")
    public void setMessages(List<String> messages) {
        this.messages = messages;
    }

    public ApplikationLog withMessages(List<String> messages) {
        this.messages = messages;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public ApplikationLog withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("inkarnation", inkarnation).append("messages", messages).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(messages).append(additionalProperties).append(inkarnation).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof ApplikationLog) == false) {
            return false;
        }
        ApplikationLog rhs = ((ApplikationLog) other);
        return new EqualsBuilder().append(messages, rhs.messages).append(additionalProperties, rhs.additionalProperties).append(inkarnation, rhs.inkarnation).isEquals();
    }

}
