
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "aenderungsGrund",
    "erstelltAm",
    "erstelltDurch",
    "versionsNummer",
    "name"
})
public class MetaDaten implements Serializable
{

    @JsonProperty("aenderungsGrund")
    private String aenderungsGrund;
    @JsonProperty("erstelltAm")
    private String erstelltAm;
    @JsonProperty("erstelltDurch")
    private String erstelltDurch;
    @JsonProperty("versionsNummer")
    private String versionsNummer;
    @JsonProperty("name")
    private String name;
    private final static long serialVersionUID = 8135096473288460439L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public MetaDaten() {
    }

    /**
     * 
     * @param erstelltAm
     * @param versionsNummer
     * @param name
     * @param aenderungsGrund
     * @param erstelltDurch
     */
    public MetaDaten(String aenderungsGrund, String erstelltAm, String erstelltDurch, String versionsNummer, String name) {
        super();
        this.aenderungsGrund = aenderungsGrund;
        this.erstelltAm = erstelltAm;
        this.erstelltDurch = erstelltDurch;
        this.versionsNummer = versionsNummer;
        this.name = name;
    }

    @JsonProperty("aenderungsGrund")
    public String getAenderungsGrund() {
        return aenderungsGrund;
    }

    @JsonProperty("aenderungsGrund")
    public void setAenderungsGrund(String aenderungsGrund) {
        this.aenderungsGrund = aenderungsGrund;
    }

    public MetaDaten withAenderungsGrund(String aenderungsGrund) {
        this.aenderungsGrund = aenderungsGrund;
        return this;
    }

    @JsonProperty("erstelltAm")
    public String getErstelltAm() {
        return erstelltAm;
    }

    @JsonProperty("erstelltAm")
    public void setErstelltAm(String erstelltAm) {
        this.erstelltAm = erstelltAm;
    }

    public MetaDaten withErstelltAm(String erstelltAm) {
        this.erstelltAm = erstelltAm;
        return this;
    }

    @JsonProperty("erstelltDurch")
    public String getErstelltDurch() {
        return erstelltDurch;
    }

    @JsonProperty("erstelltDurch")
    public void setErstelltDurch(String erstelltDurch) {
        this.erstelltDurch = erstelltDurch;
    }

    public MetaDaten withErstelltDurch(String erstelltDurch) {
        this.erstelltDurch = erstelltDurch;
        return this;
    }

    @JsonProperty("versionsNummer")
    public String getVersionsNummer() {
        return versionsNummer;
    }

    @JsonProperty("versionsNummer")
    public void setVersionsNummer(String versionsNummer) {
        this.versionsNummer = versionsNummer;
    }

    public MetaDaten withVersionsNummer(String versionsNummer) {
        this.versionsNummer = versionsNummer;
        return this;
    }

    @JsonProperty("name")
    public String getName() {
        return name;
    }

    @JsonProperty("name")
    public void setName(String name) {
        this.name = name;
    }

    public MetaDaten withName(String name) {
        this.name = name;
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("aenderungsGrund", aenderungsGrund).append("erstelltAm", erstelltAm).append("erstelltDurch", erstelltDurch).append("versionsNummer", versionsNummer).append("name", name).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(name).append(erstelltAm).append(versionsNummer).append(aenderungsGrund).append(erstelltDurch).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof MetaDaten) == false) {
            return false;
        }
        MetaDaten rhs = ((MetaDaten) other);
        return new EqualsBuilder().append(name, rhs.name).append(erstelltAm, rhs.erstelltAm).append(versionsNummer, rhs.versionsNummer).append(aenderungsGrund, rhs.aenderungsGrund).append(erstelltDurch, rhs.erstelltDurch).isEquals();
    }

}
