
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "name",
    "tcpAdresse",
    "port"
})
public class Rechner implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("name")
    private String name;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("tcpAdresse")
    private String tcpAdresse;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("port")
    private String port = "3000";
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -8250403900186929132L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public Rechner() {
    }

    /**
     * 
     * @param port
     * @param name
     * @param tcpAdresse
     */
    public Rechner(String name, String tcpAdresse, String port) {
        super();
        this.name = name;
        this.tcpAdresse = tcpAdresse;
        this.port = port;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("name")
    public String getName() {
        return name;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("name")
    public void setName(String name) {
        this.name = name;
    }

    public Rechner withName(String name) {
        this.name = name;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("tcpAdresse")
    public String getTcpAdresse() {
        return tcpAdresse;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("tcpAdresse")
    public void setTcpAdresse(String tcpAdresse) {
        this.tcpAdresse = tcpAdresse;
    }

    public Rechner withTcpAdresse(String tcpAdresse) {
        this.tcpAdresse = tcpAdresse;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("port")
    public String getPort() {
        return port;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("port")
    public void setPort(String port) {
        this.port = port;
    }

    public Rechner withPort(String port) {
        this.port = port;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public Rechner withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("name", name).append("tcpAdresse", tcpAdresse).append("port", port).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(name).append(additionalProperties).append(port).append(tcpAdresse).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof Rechner) == false) {
            return false;
        }
        Rechner rhs = ((Rechner) other);
        return new EqualsBuilder().append(name, rhs.name).append(additionalProperties, rhs.additionalProperties).append(port, rhs.port).append(tcpAdresse, rhs.tcpAdresse).isEquals();
    }

}
