
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonValue;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "option",
    "wiederholungen"
})
public class StartFehlerVerhalten implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("option")
    private StartFehlerVerhalten.Option option = StartFehlerVerhalten.Option.fromValue("ignorieren");
    @JsonProperty("wiederholungen")
    private String wiederholungen;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 574184614401432355L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StartFehlerVerhalten() {
    }

    /**
     * 
     * @param wiederholungen
     * @param option
     */
    public StartFehlerVerhalten(StartFehlerVerhalten.Option option, String wiederholungen) {
        super();
        this.option = option;
        this.wiederholungen = wiederholungen;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("option")
    public StartFehlerVerhalten.Option getOption() {
        return option;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("option")
    public void setOption(StartFehlerVerhalten.Option option) {
        this.option = option;
    }

    public StartFehlerVerhalten withOption(StartFehlerVerhalten.Option option) {
        this.option = option;
        return this;
    }

    @JsonProperty("wiederholungen")
    public String getWiederholungen() {
        return wiederholungen;
    }

    @JsonProperty("wiederholungen")
    public void setWiederholungen(String wiederholungen) {
        this.wiederholungen = wiederholungen;
    }

    public StartFehlerVerhalten withWiederholungen(String wiederholungen) {
        this.wiederholungen = wiederholungen;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StartFehlerVerhalten withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("option", option).append("wiederholungen", wiederholungen).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(wiederholungen).append(additionalProperties).append(option).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StartFehlerVerhalten) == false) {
            return false;
        }
        StartFehlerVerhalten rhs = ((StartFehlerVerhalten) other);
        return new EqualsBuilder().append(wiederholungen, rhs.wiederholungen).append(additionalProperties, rhs.additionalProperties).append(option, rhs.option).isEquals();
    }

    public enum Option {

        BEENDEN("beenden"),
        ABBRUCH("abbruch"),
        IGNORIEREN("ignorieren");
        private final String value;
        private final static Map<String, StartFehlerVerhalten.Option> CONSTANTS = new HashMap<String, StartFehlerVerhalten.Option>();

        static {
            for (StartFehlerVerhalten.Option c: values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        private Option(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return this.value;
        }

        @JsonValue
        public String value() {
            return this.value;
        }

        @JsonCreator
        public static StartFehlerVerhalten.Option fromValue(String value) {
            StartFehlerVerhalten.Option constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }

}
